
do
	local events
	
	_G.ROAIPlus = {	-- JC^[tFCXo^
		-- 萔l
		EVENT_BEGIN = 1,	-- AI֐̑OɃCxgĂ
		EVENT_END = 2,  	-- AI֐̌ɃCxgĂ
		EVENT_BOTH = 3, 	-- AI֐̑OłłCxgĂ
		
		-- ݒ
		DEBUG_PRINT = false,	-- fobOo
		
		-- API
		
		-- Cxgo^
		-- flag: EVENT_BEGINAEVENT_END  EVENT_BOTH ̂ǂꂩ
		-- func: sCxg֐ CxgsɈƂăCxgIDACxgtOn
		-- <return>: CxgID
		setEvent = function( flag, func )
			assert( type( func ) == "function")
			
			events.n = events.n + 1
			events[ events.n ] = { flag, func }
			return events.n
		end,
		
		-- Cxg擾
		-- id: ROAIPlus.setEvent ŕԂꂽCxgID
		-- <return>: CxgtOACxg֐
		getEvent = function( id )
			return unpack( events[ id ] )
		end,
		
		-- Cxg폜
		-- id: ROAIPlus.setEvent ŕԂꂽCxgID
		-- <return>: CxgtOACxg֐
		removeEvent = function( id )
			local event = events[ id ]
			events[ id ] = {}
			return unpack( event )
		end,
	}
	
	local globals = {}	-- Ԃ_G
	local loaded	-- ǂݍAI
	local Params	-- p[^ v[Xz_
	local pluginCall = false	-- vOČĂяoǂ̃tO
	
	-- CopyTable ȂǂŎg֐̓obNAbvĂ
	local raw_pairs = pairs
	local raw_io_open = io.open
	local raw_io_lines = io.lines
	local raw_io_input = io.input
	local raw_io_output = io.output
	local raw_io_read = io.read
	local raw_io_write = io.write
	local raw_io_type = io.type
	local raw_os_remove = os.remove
	local raw_os_rename = os.rename
	
	local function DebugPrint( ... )
		if not ROAIPlus.DEBUG_PRINT then
			return
		end
		local msg = ""
		for i,v in ipairs( arg ) do
			msg = msg..tostring( v ).."\t"
		end
		globals.TraceAI( msg )
	end
	
	local function CopyTable( t1, t2 )
		for k,v in raw_pairs( t1 ) do
		-- xʂƂȂIOtbLO܂ȂȂ̂Ő󂢃Rs[
		--	if type( v ) == "table" and t1 ~= v then	-- _G._G Ȃǂ̏zQƂ͏O
		--		local t = {}	-- qe[u̓N[jO
		--		CopyTable( v, t )
		--		t2[k] = t
		--	else
				t2[k] = v
		--	end
		end
	end
	
	local function CloneTable( t1, t2 )
		CopyTable( t1, t2 )
		for k,v in raw_pairs( t2 ) do	-- t2 ɂ t1 ɂȂCfbNX菜
			if not t1[k] then
				t2[k] = nil
			end
		end
	end
	
	local function DumpTable( t )
		if not ROAIPlus.DEBUG_PRINT then
			return
		end
		DebugPrint("-- Dump Table: "..globals.tostring(t) )
		for k,v in globals.pairs( t ) do
			DebugPrint( globals.tostring(k)..": "..globals.tostring(v) )
		end
		DebugPrint("-- ")
	end
	
	CopyTable( _G, globals )	-- `ĂȂԂ̃O[oRs[
	
	local function InjectFileIO( parent, name, raw_func, dir )
		parent[ name ] = function( ... )
			DebugPrint("Call IO: "..name )
			if not pluginCall then	--vOCĂяo̓pXUȂ
				for i,v in ipairs( arg ) do
					if type( v ) == "string" then
						arg[i] = globals.string.gsub( v, "USER_AI", dir )	-- USER_AI𐳂tH_
					end
					DebugPrint("arg "..i..": "..tostring(arg[i]) )
				end
			end
			local r = raw_func( unpack( arg ) )
			DebugPrint("return: "..globals.tostring(r))
			return r
		end
	end
	
	local function Protect( f )	-- ی샂[hĂяõbp[
		return function( ... )
			return pcall( f, unpack( arg ) )
		end
	end
	
	local errorCount = 0
	
	local function ProtectCall( f, ... )	-- ی샂[hĂяo
		local status, message = pcall( f, unpack( arg ) )
		if not status then
			if Params.QUIET_ERROR_MESSAGE then
				TraceAI("Error: "..message )
			else
				errorCount = errorCount + 1
				local name = "./AI/USER_AI/temp/Errors/"..string.format("%010d", errorCount )
				local fp = raw_io_open( name, "w")
				if not fp then
					DebugPrint("Error Log Open Error: "..name )
					return
				end
				fp:write( message )
				fp:close()
			end
		end
		return status
	end
	
	local traceQueue = { n = 0 }
	local prevText
	local traceCount = 0
	
	local function CustomTraceAI( text )
		if not Params.HOOK_TRACEAI then	-- JX^TraceAI
			globals.TraceAI( text )
			return
		end
		if Params.SAVE_TRACEAI then
			globals.TraceAI( text )
		end
		if Params.IGNORE_REPEAT and prevText == text then
			return
		end
		traceQueue.n = traceQueue.n + 1
		traceQueue[ traceQueue.n ] = globals.os.date("%X").." "..text.."\n"
		prevText = text
	end
	
	local function FlushTraceAI()
		if traceQueue.n == 0 then
			return
		end
		local name = "./AI/USER_AI/temp/TraceAI/"..string.format("%010d", traceCount + 1 )
		local fp = raw_io_open( name, "w")
		if not fp then
			DebugPrint("TraceAI Open Error: "..name )
			return
		end
		for i,v in ipairs( traceQueue ) do
			fp:write( v )
		end
		fp:close()
		traceQueue = { n = 0 }
		traceCount = traceCount + 1
	end
	
	local snapshot = {
		varlist = {"MyState","MyEnemy"},
	}
	
	local V_OWNER = 0	-- Const.luaǂݍ܂ȂP[X̑Ώ
	local V_POSITION = 1
	local V_MOTION = 3
	local V_HOMUNTYPE = 7
	local V_HP = 8
	local V_SP = 9
	local V_MAXHP = 10
	local V_MAXSP = 11
	
	local function Actor2Tag( id )
		local x, y = globals.GetV( V_POSITION, id )
		return string.format('<actor id="%d" homunType="%d" x="%d" y="%d" motion="%d" monster="%d" hp="%d" sp="%d" mhp="%d" msp="%d"/>',
			id,
			globals.GetV( V_HOMUNTYPE, id ),
			x, y,
			globals.GetV( V_MOTION, id ),
			globals.IsMonster( id ),
			globals.GetV( V_HP, id ),
			globals.GetV( V_SP, id ),
			globals.GetV( V_MAXHP, id ),
			globals.GetV( V_MAXSP, id ) )
	end
	
	local function SaveSnapshot()	-- ԂXML`ŕۑ
		local fp = raw_io_open("./AI/USER_AI/temp/Snapshot.xml","w")
		if not fp then
			DebugPrint("Snapshot.xml Open Error")
			return
		end
		fp:write("<?xml version='1.0' encoding='shift-jis'?>\n")
		fp:write("<snapshot>\n")
		for i,v in ipairs( snapshot.varlist ) do
			fp:write("	<variable name=\""..v.."\">"..tostring( _G[v] ).."</variable>\n")
		end
		fp:write("	<homunculus>\n")
		if MyID then
			fp:write("		"..Actor2Tag( MyID ).."\n")
		end
		fp:write("	</homunculus>\n")
		fp:write("	<owner>\n")
		if MyID then	-- V_OWNER ͑Ɋւ炸lԂAÔ
			fp:write("		"..Actor2Tag( globals.GetV( V_OWNER, MyID ) ).."\n")
		end
		fp:write("	</owner>\n")
		fp:write("</snapshot>\n")
		fp:close()
	end
	
	local function LoadChunk( path )
		local chunk = globals.loadfile( path )
		if chunk then
			return chunk()
		end
		return nil
	end
	
	local InjectAIEntryPoint
	
	local function LoadAI( name )
		if not name or name == "USER_AI" then	-- USER_AI ͖[v̂ŏO
			return
		end
		DumpTable( _G )
		CloneTable( globals, _G )	-- O[oԂ֖߂
		_G._LOADED = {}
		globals.collectgarbage()
		DumpTable( _G )
		InjectFileIO( _G, "require", globals.require, name )	-- o͊֐tbLOāAt@CpXU
		InjectFileIO( _G, "loadfile", globals.loadfile, name )
		InjectFileIO( _G, "dofile", globals.dofile, name )
		InjectFileIO( _G.io, "open", raw_io_open, name )	-- globals.io.open ㏑Ă܂̂ŁAnƖ[v
		InjectFileIO( _G.io, "lines", raw_io_lines, name )
		InjectFileIO( _G.io, "input", raw_io_input, name )
		InjectFileIO( _G.io, "output", raw_io_output, name )
		InjectFileIO( _G.io, "read", raw_io_read, name )
		InjectFileIO( _G.io, "write", raw_io_write, name )
		InjectFileIO( _G.io, "type", raw_io_type, name )
		InjectFileIO( _G.os, "remove", raw_os_remove, name )
		InjectFileIO( _G.os, "rename", raw_os_rename, name )
		TraceAI = CustomTraceAI
		ProtectCall( globals.dofile, "./AI/"..name.."/AI.lua")
		FlushTraceAI()
		DumpTable( _LOADED )
		if not AI then	-- AI֐Ȃ
			DebugPrint("Not Declared function AI") 	--  globals OĂ݂
		end
		loaded = name
		InjectAIEntryPoint()
	end
	
	local function DispatchEvents( flag )
		for id, v in ipairs( events ) do
			local f, func = unpack( v )
			if f and func and ( f == flag or f == EVENT_BOTH ) then
				pluginCall = true
				ProtectCall( func, id, flag )
				pluginCall = false
			end
		end
	end
	
	local function LoadPlugins()
		events = { n = 0 }	-- Zbg
		if not Params.PLUGINS then
			return
		end
		for i,v in ipairs( Params.PLUGINS ) do
			pluginCall = true
			ProtectCall( globals.dofile, "./AI/USER_AI/plugins/"..v..".lua")
			pluginCall = false
		end
	end
	
	local refreshCount = 0
	
	InjectAIEntryPoint = function()
		local raw_AI = AI	-- ǂݍAIAI֐ۑ
		AI = function( myid ) 	-- AI֐bv
			local params = LoadChunk("./AI/USER_AI/params.lua")
			Params = params or Params or {}	-- [hɎsȑO Params p
			if raw_AI then
				if not Params.PAUSE then	-- |[YAI֐Ă΂Ȃ
					DispatchEvents( ROAIPlus.EVENT_BEGIN )
					ProtectCall( raw_AI, myid )
					DispatchEvents( ROAIPlus.EVENT_END )
				end
				FlushTraceAI()
				if Params.USE_SNAPSHOT then
					SaveSnapshot()
				end
			end
			local ai = Params.CURRENT_AI
			if loaded ~= ai then	-- AIقȂ
				LoadAI( ai )
				LoadPlugins()
			end
			if Params.REFRESH_COUNT then	-- lƔr邽 nil ΍
				if Params.REFRESH_COUNT > refreshCount then	-- XV{^ꂽ
					refreshCount = Params.REFRESH_COUNT
					LoadAI( ai )
					LoadPlugins()
				elseif Params.REFRESH_COUNT == 0 then	-- XVJEgZbgĂȂ瓯
					refreshCount = 0
				end
			end
		end
	end
	
	InjectAIEntryPoint()	-- AIǂݍ܂܂Ŏs
end
